import bpy

from .t3d_submodels.t3d_submodel import T3DSubmodel
from .t3d_submodels.t3d_mesh import T3DMesh
from .t3d_submodels.t3d_freespotlight import T3DFreeSpotLight
from .t3d_submodels.t3d_stars import T3DStars


class SubmodelMaker:
    def wrap_in_submodel(self, obj: bpy.types.Object) -> T3DSubmodel:
        if obj.type == 'MESH':
            return T3DMesh(obj)
        elif obj.type == 'LAMP' and obj.data.type == 'SPOT':
            return T3DFreeSpotLight(obj)
        elif obj.type == 'EMPTY' and any([
                o for o in obj.children
                if o.type == 'LAMP' and o.data.type == 'POINT'
        ]):
            return T3DStars(obj)
        else:
            return None
