from typing import Iterator

import bpy

from .t3d_submodel import T3DSubmodel


class T3DStars(T3DSubmodel):
    stars_getter = None
    _submodel_typename = "Stars"

    def __init__(self, obj: bpy.types.Object):
        super().__init__(obj)
        self.stars_list = [
            obj for obj in self.obj.children
            if obj.type == 'LAMP' and obj.data.type == 'POINT'
        ]

    def get_numverts(self) -> str:
        return len(self.stars_list)

    def get_verts_groups(self) -> Iterator[str]:
        return self.stars_getter.get_stars(self.stars_list)
