from .writer_state import WriterState
from maszyna_t3d_export.src.t3d_submodels.t3d_submodel import T3DSubmodel


class FreespotligtWriterState(WriterState):
    def write_specific_properties(self, submodel: T3DSubmodel, output_file):
        output_file.writelines("".join((
            "Diffuse: {}\n".format(submodel.get_diffuse()),
            "SelfIllum: {}\n".format(submodel.get_selfillum()),
            "NearAttenStart: {}\n".format(submodel.get_near_atten_start()),
            "NearAttenEnd: {}\n".format(submodel.get_near_atten_end()),
            "UseNearAtten: {}\n".format(submodel.get_use_near_atten()),
            "FarAttenDecayType: {}\n".format(
                submodel.get_far_atten_decay_type()),
            "FarDecayRadius: {}\n".format(submodel.get_far_decay_radius()),
            "FalloffAngle: {}\n".format(submodel.get_falloff_angle()),
            "HotspotAngle: {}\n".format(submodel.get_hotspot_angle()),
        )))

    def write_verts_groups(self, submodel: T3DSubmodel, output_file):
        output_file.write("\n")
